package tantra;

/**
 * FTPサーバーにログインするために必要な情報を取り扱うためのクラス。
 * 
 * @author Luft
 * 
 */
public class FTPSetting {

	/** ホスト名 */
	public String host;
	/** サーバ上のパス */
	public String path_on_server;
	/** ユーザ名 */
	public String user_id;
	/** パスワード */
	public String user_pw;


	/**
	 * 値を指定しないコンストラクタ。全ての設定値に "" が代入されます。
	 */
	public FTPSetting() {
		host = "";
		path_on_server = "";
		user_id = "";
		user_pw = "";
	}


	/**
	 * 値を指定するコンストラクタ。
	 * 
	 * @param ihost
	 *        ホスト名、またはIPアドレス
	 * @param ipath_on_server
	 *        サーバー上のパス。末尾が "/" である必要がある
	 * @param iuser_id
	 *        ユーザーID
	 * @param iuser_pw
	 *        ユーザーパスワード
	 */
	public FTPSetting( String ihost, String ipath_on_server, String iuser_id,
			String iuser_pw ) {
		host = ihost;
		path_on_server = ipath_on_server;
		user_id = iuser_id;
		user_pw = iuser_pw;
	}

}
