package tantra;

import java.util.*;
import java.io.*;

/**
 * 
 * @author Luft
 */
public class JobList{
	private static Vector<JobListEntry> list = new Vector<JobListEntry>();

	public Job getJob( String name ){
		int i;
		for( i = 0; i < list.size(); i++ ){
			if( list.elementAt( i ).name.equals( name ) ){
				return list.elementAt( i ).job;
			}
		}
		return Job.Unknown;
	}

	
	public void commit( String name, Job job ){
		int i;
		if( list.size() <= 0 ){
			list.add( new JobListEntry( name, job ) );
			return;
		}else{
			for( i = 0; i < list.size(); i++ ){
				if( list.elementAt( i ).name.equals( name ) ){
					list.elementAt( i ).job = job;
					return;
				}
			}
			list.add( new JobListEntry( name, job ) );
			return;
		}
	}
	
	public void write(){
		try{
			BufferedWriter sw = new BufferedWriter(
					new OutputStreamWriter(
							new FileOutputStream( tantra.settings.total_data_location + File.separator + tantra.JOB_LIST ), tantra.ShiftJIS ) );
			int i;
			for( i = 0; i < list.size(); i++ ){
				sw.write( list.elementAt( i ).name + "," + list.elementAt( i ).job.getValue() );
				sw.newLine();
			}
			sw.close();
		}catch( Exception e ){
			tantra.printError( e );
		}
	}

	
	/**
	 * ファイルから、キャラクタの種族データを読み込みます。
	 */
	public void read(){
		String fpath = tantra.settings.total_data_location + File.separator + tantra.JOB_LIST;
		if( !tantra.exists( fpath )) return;
		try{
			list.removeAllElements();
			BufferedReader sr = new BufferedReader(
					new InputStreamReader(
							new FileInputStream( fpath ), tantra.ShiftJIS ) );
			String line;
			while( (line = sr.readLine()) != null ){
				list.add( new JobListEntry( line ) );
			}
			sr.close();
		}catch( Exception e ){
			tantra.printError( e );
		}
	}
}
