package tantra;

/**
 * 文字列のsplitを行う。 APIのString.splitでは日本語文字をsplitterにした時うまく動かん。
 * と思ったらStringTokenizerというのがあるらしい。まぁいいや
 * 
 * @author Luft
 */
public class Splitter {

	private int index_start[];
	private int index_end[];
	private String string;
	private String splitter;
	private int len_splitter;
	private int len_string;
	private int elements;


	/**
	 * コンストラクタ。同時にsplit操作も行う
	 * 
	 * @param string
	 *        元になる文字列
	 * @param splitter
	 *        文字列<code>string</code>の分断に使う文字列
	 */
	public Splitter( String string, String splitter ) {
		this.string = string;
		this.splitter = splitter;
		len_string = string.length();
		len_splitter = splitter.length();
		elements = -1;
		split();
	}


	/**
	 * split操作を行う。実際には、取り出すべき位置を配列に格納する。
	 */
	private void split(){

		// splitterの個数をカウント
		int index;
		int from;
		elements = 0;
		from = 0;
		index = string.indexOf( splitter, from );
		while( index >= 0 ){
			elements += 1;
			from = index + len_splitter;
			index = string.indexOf( splitter, from );
		}

		// System.out.println( "elements=" + elements );
		if( elements <= 0 ){
			return;
		}

		// splitterの位置を保存する配列を確保
		index_start = new int[elements + 1];
		index_end = new int[elements + 1];

		int current = -1;
		from = 0;
		index = string.indexOf( splitter, from );
		index_start[0] = 0;
		// System.out.println( "string=" + string );
		while( index >= 0 ){
			current += 1;
			// System.out.println( "index=" + index );
			if( index == 0 ){
				index_end[current] = 0;
			}else{
				index_end[current] = index;
			}
			// System.out.println(
			// "current,index_start[current],index_end[current]=" + current +
			// "," + index_start[current] + "," + index_end[current] );
			if( current <= elements ){
				index_start[current + 1] = index + len_splitter;
			}
			from = index + len_splitter;
			index = string.indexOf( splitter, from );
		}
		index_end[elements] = len_string;
	}


	/**
	 * 切り出した文字列を取り出します
	 * 
	 * @param index
	 *        取り出す位置
	 * @return 取り出された文字列
	 */
	public String tokenAt( int index ){
		if( 0 <= index && index <= elements ){
			return string.substring( index_start[index], index_end[index] );
		}else{
			return "";
		}
	}


	/**
	 * elementsのGetter
	 * 
	 * @return elementsの値
	 */
	public int getElements(){
		return elements;
	}


	/**
	 * splitによって生成された字句の個数
	 * 
	 * @return 個数（= elements + 1）
	 */
	public int length(){
		return elements + 1;
	}

}
