package tantra;

import java.util.*;
import java.io.*;

/**
 * ランキングへの掲載を希望しない人のリストを処理する
 * 
 * @author Luft
 */
public class SuspectList {

	private Vector<String> suspect_list = new Vector<String>();
	private String m_sFname;


	public SuspectList( String fname ) {
		m_sFname = fname;
		suspect_list.removeAllElements();
	}


	/**
	 * 指定したキャラクタが、ランキングへの掲載を希望していないかどうかを調べます
	 * 
	 * @param name
	 *        調査するキャラクタの名前
	 * @return 掲載を希望していなければtrueを、そうでなければfalseを返します
	 */
	public boolean isSuspect( String name ){
		if( suspect_list.size() <= 0 ) return false;
		String i;
		int j;
		for( j = 0; j <= suspect_list.size() - 1; j++ ){
			i = (String) suspect_list.elementAt( j );
			if( i.equals( name ) ) return true;
		}
		return false;
	}


	/**
	 * suspect list をファイルから読み込みます
	 */
	public void read(){
		String fname = m_sFname;
		// File fi = new File( fname );

		if( tantra.exists( fname ) ){
			try{
				BufferedReader unit = new BufferedReader(
						new InputStreamReader( new FileInputStream( fname ),
								tantra.ShiftJIS ) );
				String line;
				while( (line = unit.readLine()) != null ){
					suspect_list.add( line );
				}
				unit.close();
			}catch( Exception e ){
				tantra.printError( e );
			}
		}
	}
}
